//
//  UAutoreleasePool.h
//  usctp
//
//  Created by Andreas Fink on 03.11.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#if !defined(UAUTORELEASE_POOL_H)
#define UAUTORELEASE_POOL_H 1

#include "UObject.h"
#include "UList.h"
#include <pthread.h>

typedef struct UAutoreleasePool
{
    UObject                  _u;
    UList                    *_entries;
    struct UAutoreleasePool *_previous;
} UAutoreleasePool;

UAutoreleasePool *uautoreleasepool_alloc(void);
UAutoreleasePool *uautoreleasepool_init(UAutoreleasePool *u);
void uautoreleasepool_drain_pool(UAutoreleasePool *u);

void uautoreleasepool_drain(void);
void uautoreleasepool_add(UObject *u);

#define AUTORELEASE(x)          uautoreleasepool_add((UObject *)x)
#define AUTORELEASEPOOL_PUSH()  uthread_push_autoreleasepool()
#define AUTORELEASEPOOL_POP()   uthread_pop_autoreleasepool()
#define AUTORELEASEPOOL_DRAIN() uautoreleasepool_drain()

#endif /* UAUTORELEASE_POOL_H */
